(*
    ===========================================================================
    LANZX
    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt
    ---------------------------------------------------------------------------
    MMF = Memory Mapped File
    ===========================================================================
*)

unit iFMO;

interface

uses
    Windows, SysUtils;

function CreateFileMappingObject(const ADataSize: integer; const AName: string): Cardinal;
procedure DestroyFileMappingObject(var AFileMappingObject: THandle);
function GetFileMappingObject(var h: THandle; var p: Pointer; const AName: string): Boolean;
procedure ReleaseFileMappingObject(var h: THandle; var p: Pointer);

implementation

//-----------------------------------------------------------------------------
//  t@C}bsOIuWFNg쐬
function    CreateFileMappingObject(const ADataSize: integer; const AName: string): Cardinal;
begin
    //  MMF쐬
    Result := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, ADataSize, PChar(AName));
    //  G[łȂ
    if (Result = 0) then ;
end;

//-----------------------------------------------------------------------------
//  t@C}bsOIuWFNg쐬
procedure DestroyFileMappingObject(var AFileMappingObject: THandle);
begin
    //MMFJ
    if (AFileMappingObject <> 0) then
    begin
        CloseHandle(AFileMappingObject);
    end;
end;

//-----------------------------------------------------------------------------
//  LANZX̂߂̏
function GetFileMappingObject(var h: THandle; var p: Pointer; const AName: string): Boolean;
begin
    Result := true;
    //MMFJ
    h := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, PChar(AName));
    //  JȂĂȂ
    if (h = 0) then
    begin
        Result := false;
    end
    else
    //  J
    begin
        //MMF̊蓖
        p := MapViewOfFile(h, FILE_MAP_ALL_ACCESS, 0, 0, 0);
        //  蓖ĂȂĂȂ
        if (p = nil) then Result := false;
    end;
end;

//-----------------------------------------------------------------------------
//  LANZX̂߂̌n
procedure ReleaseFileMappingObject(var h: THandle; var p: Pointer);
begin
    //  MMF̃r[
    if (p <> nil) then
    begin
        UnmapViewOfFile(p);
        p := nil;
    end;
    //  MMF̃nh
    if (h <> 0) then
    begin
        CloseHandle(h);
        h := 0;
    end;
end;

end.

